@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:do_flash_ap_mtk
set /A failure_count=0

    if "%FLAG_DEVICE_HAS_LOGO%" NEQ "1" (
        goto :skip_flash_logo
    )

    set img_file=
    set img_name=LOGO
    set pt_name=logo%SLOT_SUFFIX%
    REM This is a discriminant for logo image.
    set /A A=0
    if exist logo.bin set /A A+=1 && set img_file=logo.bin
    if exist logo.img set /A A+=1 && set img_file=logo.img
    if %A% GTR 1 (
        set /A failure_count+=1
        call :view_flash_image_duplicate_error "logo.bin logo.img"
        exit /b 1
    )
    if %A% == 1 (
        call :view_flash_image_title %img_name%
        !fastboot! -s !serial_number! flash !pt_name! !img_file!
        if !errorlevel! == 1 (
            set /A failure_count+=1
            call :view_flash_image_failed !img_name!
        )
    ) else (
        REM if %A% == 0
        if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
            call :view_flash_image_not_exist_w !img_name!
        )
    )
    :skip_flash_logo

    if "%FLAG_DEVICE_HAS_VBMETA%" == "1" (
        set img_file=vbmeta.img
        set img_name=VBMETA
        set pt_name=vbmeta!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_VBMETA_SYSTEM%" == "1" (
        set img_file=vbmeta_system.img
        set img_name=VBMETA
        set pt_name=vbmeta_system!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_CAM_VPU1%" == "1" (
        set img_file=cam_vpu1.img
        set img_name=CAM_VPU1
        set pt_name=cam_vpu1!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
        rem cam_vp2
        set img_file=cam_vpu2.img
        set img_name=CAM_VPU2
        set pt_name=cam_vpu2!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
        rem cam_vp3
        set img_file=cam_vpu3.img
        set img_name=CAM_VPU3
        set pt_name=cam_vpu3!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )

    )

    if "%FLAG_DEVICE_HAS_MCF_OTA%" == "1" (
        set img_file=mcf_ota.img
        set img_name=MCF_OTA
        set pt_name=mcf_ota!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_AUDIO_DSP%" == "1" (
        set img_file=audio_dsp.img
        set img_name=AUDIO_DSP
        set pt_name=audio_dsp!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_MVPU_ALGO%" == "1" (
        set img_file=mvpu_algo.img
        set img_name=MVPU_ALGO
        set pt_name=mvpu_algo!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_CCU%" == "1" (
        set img_file=ccu.img
        set img_name=CCU
        set pt_name=ccu!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_APUSYS%" == "1" (
        set img_file=apusys.img
        set img_name=APUSYS
        set pt_name=apusys!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_CONNSYS_BT%" == "1" (
        set img_file=connsys_bt.img
        set img_name=CONNSYS_BT
        set pt_name=connsys_bt!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_CONNSYS_GNSS%" == "1" (
        set img_file=connsys_gnss.img
        set img_name=CONNSYS_GNSS
        set pt_name=connsys_gnss!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_CONNSYS_WIFI%" == "1" (
        set img_file=connsys_wifi.img
        set img_name=CONNSYS_WIFI
        set pt_name=connsys_wifi!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_BOOT%" == "1" (
        set img_file=boot.img
        set img_name=BOOT
        set pt_name=boot!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_INIT_BOOT%" == "1" (
        set img_file=init_boot.img
        set img_name=INIT_BOOT
        set pt_name=init_boot!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_VENDOR_BOOT%" == "1" (
        set img_file=vendor_boot.img
        set img_name=VENDOR_BOOT
        set pt_name=vendor_boot!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_DTB%" == "1" (
        set img_file=dtb.img
        set img_name=DTB
        set pt_name=dtb!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_RECOVERY%" == "1" (
        set img_file=recovery.img
        set img_name=RECOVERY
        set pt_name=recovery!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

    if "%FLAG_DEVICE_HAS_PVMFW%" == "1" (
        set img_file=pvmfw.img
        set img_name=PVMFW
        set pt_name=pvmfw!SLOT_SUFFIX!
        if exist "!img_file!" (
            call :view_flash_image_title !img_name!
            !fastboot! -s !serial_number! flash !pt_name! !img_file!
            if !errorlevel! == 1 (
                call :view_flash_image_failed !img_name!
                set /A failure_count+=1
            )
        ) else (
            if "!FLAG_SKIP_WARNING_PROMPT!" NEQ "1" (
                call :view_flash_image_not_exist_w !img_name!
            )
        )
    )

exit /b 0
::
:: ------------------------------ Language part ------------------------------
::
:view_flash_image_title
    echo.
    echo ------ Flashing %1 image ------
exit /b 0
::
:view_flash_image_failed
    color f6
    echo ------------------------------
    echo [Error] fastboot flashing %1 failed^^!
    echo ------------------------------
exit /b 0
::
:view_flash_image_not_exist
    echo.
    echo [Note] %1 image does not exist. Flashing skipped...
exit /b 0
::
:view_flash_image_duplicate_error
    color fc
    echo.
    echo [Fatal] Image %1 exists at the same time, this is obviously wrong, please check^^!
exit /b 0
::
:view_flash_image_not_exist_w
    echo.
    echo [Warning] Image %1 does not exist. But your device contain this partition, flashing skipped...
exit /b 0
::
:: ------------------------------ Language part End ------------------------------
::
